<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (4)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="developer-console">Developer console</h1>
    <p>
      Code is prone to errors. You will quite likely make errors… Oh, what am I
      talking about? You are <em>absolutely</em> going to make errors, at least
      if you’re a human, not a
      <a href="https://en.wikipedia.org/wiki/Bender_(Futurama)">robot</a>.
    </p>
    <p>
      But in the browser, users don’t see errors by default. So, if something
      goes wrong in the script, we won’t see what’s broken and can’t fix it.
    </p>
    <p>
      To see errors and get a lot of other useful information about scripts,
      “developer tools” have been embedded in browsers.
    </p>
    <p>
      Most developers lean towards Chrome or Firefox for development because
      those browsers have the best developer tools. Other browsers also provide
      developer tools, sometimes with special features, but are usually playing
      “catch-up” to Chrome or Firefox. So most developers have a “favorite”
      browser and switch to others if a problem is browser-specific.
    </p>
    <p>
      Developer tools are potent; they have many features. To start, we’ll learn
      how to open them, look at errors, and run JavaScript commands.
    </p>
    <h2 id="google-chrome">Google Chrome</h2>
    <p>Open the page <a href="bug.html">bug.html</a>.</p>
    <p>
      There’s an error in the JavaScript code on it. It’s hidden from a regular
      visitor’s eyes, so let’s open developer tools to see it.
    </p>
    <p>
      Press <code>key:F12</code> or, if you’re on Mac, then
      <code>key:Cmd+Opt+J</code>.
    </p>
    <p>The developer tools will open on the Console tab by default.</p>
    <p>It looks somewhat like this:</p>
    <figure>
      <img src="chrome.png" alt="chrome" />
      <figcaption>chrome</figcaption>
    </figure>
    <p>
      The exact look of developer tools depends on your version of Chrome. It
      changes from time to time but should be similar.
    </p>
    <ul>
      <li>
        Here we can see the red-colored error message. In this case, the script
        contains an unknown “lalala” command.
      </li>
      <li>
        On the right, there is a clickable link to the source
        <code>bug.html:12</code> with the line number where the error has
        occurred.
      </li>
    </ul>
    <p>
      Below the error message, there is a blue <code>&gt;</code> symbol. It
      marks a “command line” where we can type JavaScript commands. Press
      <code>key:Enter</code> to run them.
    </p>
    <p>
      Now we can see errors, and that’s enough for a start. We’ll come back to
      developer tools later and cover debugging more in-depth in the chapter
      <a href="info:debugging-chrome" class="uri">info:debugging-chrome</a>.
    </p>
    <p>
      ``<code
        >smart header="Multi-line input" Usually, when we put a line of code
        into the console, and then press</code
      >key:Enter`, it executes.
    </p>
    <p>
      To insert multiple lines, press <code>key:Shift+Enter</code>. This way one
      can enter long fragments of JavaScript code. ```
    </p>
    <h2 id="firefox-edge-and-others">Firefox, Edge, and others</h2>
    <p>Most other browsers use <code>key:F12</code> to open developer tools.</p>
    <p>
      The look &amp; feel of them is quite similar. Once you know how to use one
      of these tools (you can start with Chrome), you can easily switch to
      another.
    </p>
    <h2 id="safari">Safari</h2>
    <p>
      Safari (Mac browser, not supported by Windows/Linux) is a little bit
      special here. We need to enable the “Develop menu” first.
    </p>
    <p>
      Open Preferences and go to the “Advanced” pane. There’s a checkbox at the
      bottom:
    </p>
    <figure>
      <img src="safari.png" alt="safari" />
      <figcaption>safari</figcaption>
    </figure>
    <p>
      Now <code>key:Cmd+Opt+C</code> can toggle the console. Also, note that the
      new top menu item named “Develop” has appeared. It has many commands and
      options.
    </p>
    <h2 id="summary">Summary</h2>
    <ul>
      <li>
        Developer tools allow us to see errors, run commands, examine variables,
        and much more.
      </li>
      <li>
        They can be opened with <code>key:F12</code> for most browsers on
        Windows. Chrome for Mac needs <code>key:Cmd+Opt+J</code>, Safari:
        <code>key:Cmd+Opt+C</code> (need to enable first).
      </li>
    </ul>
    <p>
      Now we have the environment ready. In the next section, we’ll get down to
      JavaScript.
    </p>
  </body>
</html>
